VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "MODBUS Reader"
   ClientHeight    =   8475
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4890
   LinkTopic       =   "Form1"
   ScaleHeight     =   8475
   ScaleWidth      =   4890
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      Caption         =   "Data Format"
      Height          =   855
      Left            =   120
      TabIndex        =   23
      Top             =   3120
      Width           =   4575
      Begin VB.OptionButton optFormat 
         Caption         =   "Decimal"
         Height          =   255
         Index           =   0
         Left            =   720
         TabIndex        =   25
         Top             =   360
         Value           =   -1  'True
         Width           =   1215
      End
      Begin VB.OptionButton optFormat 
         Caption         =   "Hexadecimal"
         Height          =   255
         Index           =   1
         Left            =   2760
         TabIndex        =   24
         Top             =   360
         Width           =   1335
      End
   End
   Begin VB.Frame Frame5 
      Caption         =   "Write To Device"
      Height          =   1455
      Left            =   0
      TabIndex        =   16
      Top             =   6960
      Width           =   4815
      Begin VB.TextBox txtWrite 
         Height          =   375
         Left            =   240
         TabIndex        =   22
         Top             =   720
         Width           =   1695
      End
      Begin VB.CommandButton btnWrite 
         Caption         =   "Write"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   2880
         TabIndex        =   17
         Top             =   600
         Width           =   1575
      End
      Begin VB.Label Label7 
         Caption         =   "Value to Write"
         Height          =   255
         Left            =   360
         TabIndex        =   18
         Top             =   480
         Width           =   1455
      End
   End
   Begin VB.Frame Frame4 
      Caption         =   "Read From Device"
      Height          =   2775
      Left            =   0
      TabIndex        =   13
      Top             =   4080
      Width           =   4815
      Begin VB.TextBox inpNumItems 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   3360
         TabIndex        =   26
         Text            =   "Text2"
         Top             =   600
         Width           =   795
      End
      Begin VB.CommandButton btnRead 
         Caption         =   "&Read"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   3000
         TabIndex        =   20
         Top             =   1200
         Width           =   1575
      End
      Begin VB.CommandButton btnPoll 
         Caption         =   "Poll"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   12
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   495
         Left            =   3000
         TabIndex        =   19
         Top             =   1800
         Width           =   1575
      End
      Begin VB.ListBox lstData 
         Height          =   1425
         Left            =   240
         TabIndex        =   15
         Top             =   840
         Width           =   2535
      End
      Begin VB.Label Label6 
         Alignment       =   2  'Center
         Caption         =   "Num Items"
         Height          =   255
         Left            =   3360
         TabIndex        =   27
         Top             =   360
         Width           =   855
      End
      Begin VB.Label lblElapsedTime 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   240
         TabIndex        =   21
         Top             =   2400
         Width           =   2535
      End
      Begin VB.Label Label8 
         Caption         =   "Value(s) Read"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   600
         Width           =   2175
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Controller Settings"
      Height          =   1335
      Left            =   0
      TabIndex        =   7
      Top             =   1680
      Width           =   4815
      Begin VB.TextBox inpDataAddr 
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   2858
         TabIndex        =   10
         Text            =   "Text1"
         Top             =   600
         Width           =   1215
      End
      Begin VB.ComboBox cmbCtlrAddr 
         Height          =   315
         Left            =   818
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   600
         Width           =   1215
      End
      Begin VB.Label Label5 
         Alignment       =   2  'Center
         Caption         =   "Data Address"
         Height          =   255
         Left            =   2858
         TabIndex        =   11
         Top             =   360
         Width           =   1215
      End
      Begin VB.Label Label4 
         Alignment       =   2  'Center
         Caption         =   "Controller Addr"
         Height          =   255
         Left            =   818
         TabIndex        =   9
         Top             =   360
         Width           =   1215
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Communication Settings"
      Height          =   1575
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4815
      Begin VB.CommandButton btnOpen 
         Caption         =   "&Open Port"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   375
         Left            =   1275
         TabIndex        =   12
         Top             =   1080
         Width           =   2295
      End
      Begin VB.ComboBox cmbParity 
         Height          =   315
         Left            =   3375
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   600
         Width           =   1080
      End
      Begin VB.ComboBox cmbPort 
         Height          =   315
         Left            =   1815
         Style           =   2  'Dropdown List
         TabIndex        =   2
         Top             =   600
         Width           =   1335
      End
      Begin VB.ComboBox cmbBaudRate 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   600
         Width           =   1335
      End
      Begin VB.Label Label3 
         Alignment       =   2  'Center
         Caption         =   "Parity"
         Height          =   255
         Left            =   3375
         TabIndex        =   6
         Top             =   360
         Width           =   1080
      End
      Begin VB.Label Label2 
         Alignment       =   2  'Center
         Caption         =   "Port"
         Height          =   255
         Left            =   1815
         TabIndex        =   5
         Top             =   360
         Width           =   1320
      End
      Begin VB.Label Label1 
         Alignment       =   2  'Center
         Caption         =   "Baud Rate"
         Height          =   255
         Left            =   255
         TabIndex        =   4
         Top             =   360
         Width           =   1320
      End
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   0
      Top             =   4920
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Const CLS_SP_ADDRESS = 40331    ' The MODBUS address of the Set Point for loop #1 of a CLS controller
Const CLS_PV_ADDRESS = 40364    ' The MODBUS address of the Process Variable for loop #1 of a CLS controller

Public portStr As String                ' The name of the COM PORT e.g. "COM1", "COM2", "ROCKET1"
Public parity As Integer                ' 0=None, 1=Odd, 2=Even
Public baudRate As Long                 '9600, 19200, etc

Public hComm As Long                    ' A handle to the open COM port, that is returned from the call to Open the Port.
                                                  ' This handle is thereafter to be used whenever we read, write, or close that port.

Public numChans As Integer            ' Indicates the number of consequetive items to be read from an address
Public dataAddress As Long             ' The MODBUS parameter address to read data from or write data to
Public ctlrAddress As Integer         ' The controller communication address to read data from or write data to

Public result%

Dim portOpen As Boolean

Dim pollingNow As Boolean




'  Handles displaying the string of characters passed between the MODBUS Host and Slave when a Read command is issued.
' The communication stream will be displayed in the "Comm Strings" window.
Public Sub debugRead()
        Dim byteArray(0 To 300) As Byte
        Dim debugStr$, strSize%, i%

        strSize = WA_getReadString(hComm, byteArray(0))
        debugStr = "Sent:"
        For i = 0 To strSize - 1
            debugStr = debugStr & Hex$(byteArray(i)) & " "
        Next i
        Debug.Print debugStr
        frmStatus.List1.AddItem debugStr
        
        strSize = WA_getReadResponse(hComm, byteArray(0))
        debugStr = "Received:"
        For i = 0 To strSize - 1
            debugStr = debugStr & Hex$(byteArray(i)) & " "
        Next i
        Debug.Print debugStr
        frmStatus.List1.AddItem debugStr
End Sub


'  Handles displaying the string of characters passed between the MODBUS Host and Slave when a Write command is issued.
' The communication stream will be displayed in the "Comm Strings" window.
Public Sub debugWrite()
        Dim byteArray(0 To 300) As Byte
        Dim debugStr$, strSize%, i%

        strSize = WA_getWriteString(hComm, byteArray(0))
        debugStr = "Sent:"
        For i = 0 To strSize - 1
            debugStr = debugStr & Hex$(byteArray(i)) & " "
        Next i
        Debug.Print debugStr
        frmStatus.List1.AddItem debugStr
        
        strSize = WA_getWriteResponse(hComm, byteArray(0))
        debugStr = "Received:"
        For i = 0 To strSize - 1
            debugStr = debugStr & Hex$(byteArray(i)) & " "
        Next i
        Debug.Print debugStr
        frmStatus.List1.AddItem debugStr

End Sub

' Interpret the error value returned when call to read or write fails
Private Function getErrorStr(val%, dataVal%)
    Select Case (val)
        Case -6: getErrorStr = "HOST_REJECTED_DATA_LENGTH"
        Case -5: getErrorStr = "HOST_REJECTED_START_ADDRESS"
        Case -4: getErrorStr = "HOST_RECEIVED_IO_ERR_SENDING"
        Case -3: getErrorStr = "HOST_RECEIVED_MODBUS_ERROR"
        Select Case dataVal
        End Select
        Case -2: getErrorStr = "HOST_RECEIVED_TIMEOUT_ERROR"
        Case -1: getErrorStr = "HOST_RECEIVED_CHECKSUM_ERROR"
    End Select
End Function

Private Sub pollRoutine()
    Dim intArray(0 To 200) As Integer, i%, strSize%
    Dim pollCtr As Long
    Dim currentTickCount As Long
    Dim lastTickCount As Long
        
    lastTickCount = GetTickCount

    While pollingNow
        pollCtr = pollCtr + 1
        DoEvents
        
        If pollingNow Then
            ' The WATCONNECT call to read data from a MODBUS device
            result = WA_readModbusDevice(hComm, ctlrAddress, dataAddress, intArray(0), numChans)
            
            currentTickCount = GetTickCount
            lblElapsedTime.Caption = "Addr:" & ctlrAddress & " poll#:" & pollCtr & "   " & currentTickCount - lastTickCount & " ms"
            lastTickCount = currentTickCount
            
            lstData.Clear
            ' Display data read up from controller in listbox
            For i = 0 To numChans - 1
                If result = 0 Then
                    lstData.AddItem Str(intArray(i))
                Else
                    lstData.AddItem getErrorStr(result, intArray(0))
                End If
            Next i
            
            'ctlrAddress = ctlrAddress + 1
            'If ctlrAddress = 4 Then ctlrAddress = 1
        End If
    Wend
End Sub

Public Function ReadModbus(ByVal ModbusAddress As Integer, ByVal Register As Long, ByRef returnValue As Variant, ByVal NumRegisters As Integer) As Integer
    Dim iData() As Integer, i%
    ReDim iData(0 To NumRegisters - 1)
    
On Error GoTo GOTERR
    
      ReadModbus = WA_readModbusDevice(hComm, ModbusAddress, Register, iData(0), NumRegisters)
      
      ' Redimension variant to required size
      ReDim returnValue(0 To NumRegisters - 1)
      ' Stuff variant with integer values returned from controller
      For i = 0 To NumRegisters - 1
        returnValue(i) = iData(i)
      Next i
Exit Function

GOTERR:
    ReadModbus = 1

End Function

' Open or Close the COM port
Private Sub btnOpen_Click()

    If Not portOpen Then
    
        portStr = "COM" & cmbPort.ListIndex + 1
        
        Select Case cmbBaudRate.ListIndex
            Case 0: baudRate = 9600
            Case 1: baudRate = 19200
            Case 2: baudRate = 28800
            Case 3: baudRate = 38400
            Case 4: baudRate = 56000
            Case 5: baudRate = 57600
            Case 6: baudRate = 115200
            Case 6: baudRate = 128000
            Case 7: baudRate = 256000
        End Select
        Select Case cmbParity.ListIndex
            Case 0: parity = 0
            Case 1: parity = 1
            Case 2: parity = 2
        End Select
        
        ' The WATCONNECT call to open the COM port
        result = WA_openVBModbusConnection(hComm, portStr, baudRate, parity)
        
        If result <> 0 Then     ' Attempt to open port failed, notify user
            Call MsgBox("Can not open port", vbCritical, "Port ERROR")
            portOpen = False
        Else                            ' Attempt to open port succeeded, enable controls
            btnOpen.Caption = "Close Port"
            cmbPort.Enabled = False
            cmbBaudRate.Enabled = False
            cmbParity.Enabled = False
            
            cmbCtlrAddr.Enabled = True
            inpDataAddr.Enabled = True
            inpNumItems.Enabled = True
            btnRead.Enabled = True
            btnWrite.Enabled = True
            btnPoll.Enabled = True
            optFormat(0).Enabled = True
            optFormat(1).Enabled = True
            portOpen = True
        End If
    Else        ' Closing port
            
    
        btnOpen.Caption = "Open Port"
        cmbPort.Enabled = True
        cmbBaudRate.Enabled = True
        cmbParity.Enabled = True
        
        cmbCtlrAddr.Enabled = False
        inpDataAddr.Enabled = False
        inpNumItems.Enabled = False
        btnRead.Enabled = False
        btnWrite.Enabled = False
        btnPoll.Enabled = False
        optFormat(0).Enabled = False
        optFormat(1).Enabled = False
        
        ' The WATCONNECT call to close the COM port
        Call WA_closeModbusConnection(hComm)
        portOpen = False
    End If
End Sub

Private Sub btnPoll_Click()
    If pollingNow Then
        btnPoll.Caption = "Poll"
        btnRead.Enabled = True
        pollingNow = False
    Else
        btnPoll.Caption = "Stop Polling"
        btnRead.Enabled = False
        pollingNow = True
        Timer1.Enabled = True
    End If
End Sub

' Fetches data from the device and displays the values read
Private Sub btnRead_Click()
        Dim intArray(0 To 200) As Integer, i%, strSize%
        Dim returnValue As Variant

        ' Notify user read is in process by switching to Hourglass cursor
        Screen.MousePointer = vbHourglass
        
        ' The WATCONNECT call to read data from a MODBUS device
        'result = WA_readModbusDevice(hComm, ctlrAddress, dataAddress, intArray(0), numChans)
        result = ReadModbus(ctlrAddress, dataAddress, returnValue, numChans)
        
        Screen.MousePointer = vbDefault
        
        lstData.Clear
        ' Display data read up from controller in listbox
        For i = 0 To numChans - 1
            If result = 0 Then
                If optFormat(0).value = True Then
                    lstData.AddItem Str(returnValue(i))
                Else
                    lstData.AddItem Hex$(returnValue(i))
                End If
            Else
                lstData.AddItem getErrorStr(result, CInt(returnValue(0)))
            End If
        Next i
        Call debugRead
End Sub

' Sends data to the device, only one item or "loop" of data will be downloaded.
Private Sub btnWrite_Click()
Dim intArray() As Integer
ReDim intArray(0 To 0)
        
On Error GoTo GOTERR
        
        If optFormat(0).value = True Then
            intArray(0) = CInt(txtWrite.Text)
        Else
            intArray(0) = CInt("&H" & txtWrite.Text)
        End If
        
        ' The WATCONNECT call to send data to a MODBUS device
        result = WA_writeModbusDevice(hComm, ctlrAddress, dataAddress, intArray(0), 1)
        
        Call debugWrite
Exit Sub

GOTERR:
    MsgBox (txtWrite.Text & " is not a valid number.")
End Sub


Private Sub cmbCtlrAddr_Click()
    ctlrAddress = cmbCtlrAddr.ListIndex + 1
End Sub


Private Sub Form_Load()
    Dim commIndex%
    
    ReDim intArray(0 To 200)
    Dim portStr$
    
    ' Load user interface elements with possible selections
    ' Baud Rates
    cmbBaudRate.AddItem "9600"
    cmbBaudRate.AddItem "19200"
    cmbBaudRate.AddItem "28800"
    cmbBaudRate.AddItem "38400"
    cmbBaudRate.AddItem "56000"
    cmbBaudRate.AddItem "57600"
    cmbBaudRate.AddItem "115200"
    cmbBaudRate.ListIndex = 1
    
    ' COM Ports
    For commIndex = 1 To 9
        cmbPort.AddItem "COM " & commIndex
    Next commIndex
    cmbPort.ListIndex = 1
    
    ' Parity settings
    cmbParity.AddItem "None"
    cmbParity.AddItem "Odd"
    cmbParity.AddItem "Even"
    cmbParity.ListIndex = 0
    
    ' Controller communication addresses
    cmbCtlrAddr.Clear
    Dim i%
    For i = 1 To 64
        cmbCtlrAddr.AddItem Str(i)
    Next i
    cmbCtlrAddr.ListIndex = 0
    
    ' Default data address to read corresponds to the Process Variable location in a CLS multi-loop controller
    dataAddress = CLS_PV_ADDRESS
    inpDataAddr.Text = Str(dataAddress)
    
    ' Read 5 channels of data by default
    numChans = 5
    inpNumItems.Text = Str(numChans)
    
    cmbCtlrAddr.Enabled = False
    inpDataAddr.Enabled = False
    inpNumItems.Enabled = False
    btnRead.Enabled = False
    btnWrite.Enabled = False
    btnPoll.Enabled = False
    optFormat(0).Enabled = False
    optFormat(1).Enabled = False
    
    frmStatus.Show 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' When shutting down this app remember to close the port if not already closed
    If portOpen Then Call WA_closeModbusConnection(hComm)
    
    Unload frmStatus
End Sub




Private Sub inpDataAddr_Change()
    Dim value
    
    value = val(inpDataAddr.Text)
    If value > 33000 And value < 50000 Then
        dataAddress = value
    End If

End Sub

Private Sub inpNumItems_Change()
    Dim value
    
    value = val(inpNumItems.Text)
    If value > 0 And value < 65 Then
        numChans = value
    End If

End Sub

Private Sub optFormat_Click(Index As Integer)
    Dim i%
    
On Error GoTo GOTERR
    
    If Index = 0 Then 'decimal format
        For i = 0 To lstData.ListCount - 1
            lstData.List(i) = val("&H" & lstData.List(i))
        Next i
    Else
        For i = 0 To lstData.ListCount - 1
            lstData.List(i) = Hex$(lstData.List(i))
        Next i
    End If



On Error GoTo GOTERR
    If Index = 0 Then 'decimal format
            txtWrite.Text = val("&H" & txtWrite.Text) & Chr$(13)
    Else
            txtWrite.Text = Hex$(txtWrite.Text) & Chr$(13)
    End If
    
Exit Sub

GOTERR:
    Dim result
    'result = MsgBox("Conversion Error", vbExclamation, "Info")

End Sub

Private Sub Timer1_Timer()
    Timer1.Interval = 100
    Call pollRoutine
    Timer1.Enabled = False
End Sub

